/* eslint-disable no-param-reassign */
import { JSCodeshift, Collection } from 'jscodeshift';
import { paramCase } from 'param-case';

const fontProps = [
  'fontFamily',
  'fontSize',
  'fontWeight',
  'letterSpacing',
  'lineHeight',
  'textTransform',
  'textDecoration',
];

export default function updateFontProps(j: JSCodeshift, source: Collection) {
  source
    .findJSXElements('Typography')
    .find(j.JSXAttribute)
    .filter((attribute) =>
      fontProps.includes(attribute.node.name.name as string),
    )
    .find(j.Literal)
    .forEach((literal) => {
      literal.node.value = paramCase(literal.node.value as string);
    });
}
