import React from 'react';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import typographyColorTokens from '@highlight-ui/tokens/dist/typography/colors.json';
import typographyFontFamilyTokens from '@highlight-ui/tokens/dist/typography/fontFamilies.json';
import typographyFontSizeTokens from '@highlight-ui/tokens/dist/typography/fontSizes.json';
import typographyFontWeightTokens from '@highlight-ui/tokens/dist/typography/fontWeights.json';
import typographyTextCaseTokens from '@highlight-ui/tokens/dist/typography/textCase.json';
import typographyTextDecorationTokens from '@highlight-ui/tokens/dist/typography/textDecoration.json';
import typographyLetterSpacingTokens from '@highlight-ui/tokens/dist/typography/letterSpacing.json';
import typographyLineHeightTokens from '@highlight-ui/tokens/dist/typography/lineHeights.json';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$1 = {
  "heading-xsmall": "TokenisedTypography-module__onwaDh1v__v6-2-10",
  "heading-small": "TokenisedTypography-module__EzGiEkH0__v6-2-10",
  "heading-medium": "TokenisedTypography-module__aJ6ON-c9__v6-2-10",
  "heading-large": "TokenisedTypography-module__OdqVI7Gq__v6-2-10",
  "heading-xlarge": "TokenisedTypography-module__sKayCNWr__v6-2-10",
  "heading-2xl": "TokenisedTypography-module__tdP9nm1h__v6-2-10",
  "body-small": "TokenisedTypography-module__5SGkIeIV__v6-2-10",
  "body-base": "TokenisedTypography-module__33RfT-o2__v6-2-10",
  "body-large": "TokenisedTypography-module__6qCKH0-X__v6-2-10",
  "body-strong-small": "TokenisedTypography-module__JhRHUPNe__v6-2-10",
  "body-strong-base": "TokenisedTypography-module__4m-jV2Cj__v6-2-10",
  "body-strong-large": "TokenisedTypography-module__mDM8xaOH__v6-2-10",
  "page-heading": "TokenisedTypography-module__vfaNn-y6__v6-2-10",
  "button": "TokenisedTypography-module__06-oo8NN__v6-2-10",
  "form-label": "TokenisedTypography-module__WLEBFNws__v6-2-10",
  "caption": "TokenisedTypography-module__eXnfr---__v6-2-10",
  "text-link-default": "TokenisedTypography-module__SY0XbgdQ__v6-2-10",
  "text-link-hover": "TokenisedTypography-module__iyPbDdvh__v6-2-10",
  "table-data-regular": "TokenisedTypography-module__cEJrzxvS__v6-2-10",
  "table-data-bold": "TokenisedTypography-module__hsz-gpO6__v6-2-10"
};
var TokenisedTypographyWithRef = function (_a, ref) {
  var children = _a.children,
    className = _a.className,
    _b = _a.component,
    component = _b === void 0 ? 'p' : _b,
    _c = _a.token,
    token = _c === void 0 ? 'body-base' : _c,
    color = _a.color,
    style = _a.style,
    fontFamily = _a.fontFamily,
    fontSize = _a.fontSize,
    fontWeight = _a.fontWeight,
    letterSpacing = _a.letterSpacing,
    lineHeight = _a.lineHeight,
    textTransform = _a.textTransform,
    textDecoration = _a.textDecoration,
    metadata = _a.metadata,
    otherProps = __rest(_a, ["children", "className", "component", "token", "color", "style", "fontFamily", "fontSize", "fontWeight", "letterSpacing", "lineHeight", "textTransform", "textDecoration", "metadata"]);
  return /*#__PURE__*/React.createElement(component, __assign(__assign(__assign({}, otherProps), parseMetadata(metadata)), {
    ref: ref,
    style: __assign({
      color: color && typographyColorTokens[color],
      fontFamily: fontFamily && typographyFontFamilyTokens[fontFamily],
      fontSize: fontSize && typographyFontSizeTokens[fontSize],
      fontWeight: fontWeight && typographyFontWeightTokens[fontWeight],
      letterSpacing: letterSpacing && typographyLetterSpacingTokens[letterSpacing],
      lineHeight: lineHeight && typographyLineHeightTokens[lineHeight],
      textTransform: textTransform && typographyTextCaseTokens[textTransform],
      textDecoration: textDecoration && typographyTextDecorationTokens[textDecoration]
    }, style),
    className: classnames(styles$1[token], className)
  }), children);
};
TokenisedTypographyWithRef.displayName = 'TokenisedTypography';
/**
 * @deprecated This component is deprecated and will be removed in future releases.
 * Please use `Heading` or `Body` instead.
 */
var TokenisedTypography = /*#__PURE__*/React.forwardRef(TokenisedTypographyWithRef);
var bodyVariantProps = {
  large: {
    fontSize: 'large',
    lineHeight: 'base',
    fontWeight: 'regular'
  },
  small: {
    fontSize: 'small',
    lineHeight: 'base',
    fontWeight: 'regular'
  },
  'strong-large': {
    fontSize: 'large',
    lineHeight: 'base',
    fontWeight: 'bold'
  },
  'strong-base': {
    fontSize: 'base',
    lineHeight: 'large',
    fontWeight: 'bold'
  },
  'strong-small': {
    fontSize: 'small',
    lineHeight: 'base',
    fontWeight: 'bold'
  },
  base: {
    fontSize: 'base',
    lineHeight: 'large',
    fontWeight: 'regular'
  }
};
var headingVariantProps = {
  '2xlarge': {
    fontSize: '3xl',
    lineHeight: 'base'
  },
  xlarge: {
    fontSize: '2xl',
    lineHeight: 'base'
  },
  large: {
    fontSize: 'xlarge',
    lineHeight: 'base'
  },
  medium: {
    fontSize: 'large',
    lineHeight: 'base'
  },
  small: {
    fontSize: 'base',
    lineHeight: 'large'
  },
  xsmall: {
    fontSize: 'small',
    lineHeight: 'large'
  }
};
var styles = {
  "truncate": "BaseTypography-module__gDqXh7PB__v6-2-10",
  "font-family-default": "BaseTypography-module__NmOUTvM0__v6-2-10",
  "font-family-mono": "BaseTypography-module__po5OsKvS__v6-2-10",
  "font-family-icon": "BaseTypography-module__dqFq7Ex4__v6-2-10",
  "font-size-xsmall": "BaseTypography-module__C-LvOSG6__v6-2-10",
  "font-size-small": "BaseTypography-module__J3YrpXUR__v6-2-10",
  "font-size-base": "BaseTypography-module__8AgIdCaP__v6-2-10",
  "font-size-large": "BaseTypography-module__l9zhB-Zw__v6-2-10",
  "font-size-xlarge": "BaseTypography-module__ZA4BOkms__v6-2-10",
  "font-size-2xl": "BaseTypography-module__WLdubQwo__v6-2-10",
  "font-size-3xl": "BaseTypography-module__HeXVoMo-__v6-2-10",
  "font-weight-regular": "BaseTypography-module__yf4pXXyL__v6-2-10",
  "font-weight-semi-bold": "BaseTypography-module__05CxVvXB__v6-2-10",
  "font-weight-bold": "BaseTypography-module__M9m6ZH--__v6-2-10",
  "letter-spacing-base": "BaseTypography-module__SU2CO98j__v6-2-10",
  "line-height-base": "BaseTypography-module__C4ENtalM__v6-2-10",
  "line-height-large": "BaseTypography-module__6HvLgJ81__v6-2-10",
  "line-height-xlarge": "BaseTypography-module__Rgd21ujg__v6-2-10",
  "text-decoration-none": "BaseTypography-module__GSBUAW-e__v6-2-10",
  "text-decoration-underline": "BaseTypography-module__EhGtBpHg__v6-2-10",
  "text-case-none": "BaseTypography-module__4cilEc6K__v6-2-10",
  "text-case-uppercase": "BaseTypography-module__615YmmQJ__v6-2-10",
  "color-text-default": "BaseTypography-module__R2VZGFXf__v6-2-10",
  "color-text-subdued": "BaseTypography-module__hMy86pq9__v6-2-10",
  "color-text-hover": "BaseTypography-module__TTgrEHET__v6-2-10",
  "color-text-disabled": "BaseTypography-module__-JmQP03c__v6-2-10",
  "color-text-hint-text": "BaseTypography-module__6UJA7Uou__v6-2-10",
  "color-text-on-primary": "BaseTypography-module__pAq7CRL3__v6-2-10",
  "color-text-on-emphasis": "BaseTypography-module__AAWdp88x__v6-2-10",
  "color-text-on-secondary": "BaseTypography-module__MK-EpEz5__v6-2-10",
  "color-text-on-secondary-disabled": "BaseTypography-module__Zl6pJmtZ__v6-2-10",
  "color-text-on-action-critical": "BaseTypography-module__2nncY0zu__v6-2-10",
  "color-text-on-action-success": "BaseTypography-module__1nLJo2nO__v6-2-10",
  "color-text-on-interactive": "BaseTypography-module__hz7awz-q__v6-2-10",
  "color-text-on-interactive-subdued": "BaseTypography-module__cNLOfx9F__v6-2-10",
  "color-text-on-background-warning": "BaseTypography-module__sGgr2ezo__v6-2-10",
  "color-text-on-background-critical": "BaseTypography-module__UKmQ8dx7__v6-2-10",
  "color-text-on-background-success": "BaseTypography-module__YIv-E-Qk__v6-2-10",
  "typographyReset": "BaseTypography-module__JG0dB-pS__v6-2-10"
};
var BaseTypography = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var _b, _c;
  var _d = _a.as,
    as = _d === void 0 ? 'span' : _d,
    color = _a.color,
    _e = _a.truncate,
    truncate = _e === void 0 ? false : _e,
    _f = _a.fontFamily,
    fontFamily = _f === void 0 ? 'default' : _f,
    _g = _a.fontSize,
    fontSize = _g === void 0 ? 'base' : _g,
    _h = _a.fontWeight,
    fontWeight = _h === void 0 ? 'regular' : _h,
    _j = _a.letterSpacing,
    letterSpacing = _j === void 0 ? 'base' : _j,
    _k = _a.lineHeight,
    lineHeight = _k === void 0 ? 'base' : _k,
    _l = _a.textTransform,
    textTransform = _l === void 0 ? 'none' : _l,
    _m = _a.textDecoration,
    textDecoration = _m === void 0 ? 'none' : _m,
    children = _a.children,
    metadata = _a.metadata,
    rest = __rest(_a, ["as", "color", "truncate", "fontFamily", "fontSize", "fontWeight", "letterSpacing", "lineHeight", "textTransform", "textDecoration", "children", "metadata"]);
  var Component = as;
  var typographyClass = classnames(styles.typographyReset, ["font-family-" + fontFamily, "font-size-" + fontSize, "font-weight-" + fontWeight, "letter-spacing-" + letterSpacing, "line-height-" + lineHeight, "text-case-" + textTransform, "text-decoration-" + textDecoration].map(function (className) {
    return styles[className];
  }), (_b = {}, _b[styles["color-" + color]] = color, _b), (_c = {}, _c[styles.truncate] = truncate, _c));
  return /*#__PURE__*/React.createElement(Component, __assign({
    className: typographyClass,
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    ref: ref
  }, parseMetadata(metadata), rest), children);
});
var Body = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var _b = _a.as,
    as = _b === void 0 ? 'span' : _b,
    color = _a.color,
    _c = _a.variant,
    variant = _c === void 0 ? 'base' : _c,
    _d = _a.truncate,
    truncate = _d === void 0 ? false : _d,
    children = _a.children,
    id = _a.id,
    title = _a.title,
    metadata = _a.metadata;
  return /*#__PURE__*/React.createElement(BaseTypography, __assign({
    as: as,
    ref: ref,
    color: color,
    truncate: truncate,
    fontFamily: "default",
    textTransform: "none",
    textDecoration: "none",
    letterSpacing: "base",
    id: id,
    title: title,
    metadata: metadata
  }, bodyVariantProps[variant]), children);
});
var Heading = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var as = _a.as,
    color = _a.color,
    variant = _a.variant,
    _b = _a.truncate,
    truncate = _b === void 0 ? false : _b,
    children = _a.children,
    id = _a.id,
    title = _a.title,
    metadata = _a.metadata;
  return /*#__PURE__*/React.createElement(BaseTypography, __assign({
    as: as,
    ref: ref,
    color: color,
    truncate: truncate,
    fontWeight: "bold",
    fontFamily: "default",
    textTransform: "none",
    textDecoration: "none",
    letterSpacing: "base",
    id: id,
    title: title,
    metadata: metadata
  }, headingVariantProps[variant]), children);
});
export { Body, Heading, TokenisedTypography, TokenisedTypography as Typography };
//# sourceMappingURL=index.js.map
